From 508b9eac5f5c0fc8bcf8b299664e68f338c416c4 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:40:40 +0000
Subject: [PATCH 871/1001] The stream does not need the username in the URL


---

diff --git a/hubs/tests/views/test_user.py b/hubs/tests/views/test_user.py
index a31a782..7df2c1d 100644
--- a/hubs/tests/views/test_user.py
+++ b/hubs/tests/views/test_user.py
@@ -15,23 +15,23 @@ class TestGetNotifications(hubs.tests.APPTest):
         name = 'notarealfasuser'
 
         with hubs.tests.auth_set(app, self.user):
-            resp = self.app.get('/{}/notifications/'.format(name))
+            resp = self.app.get('/stream/saved/'.format(name))
         self.assertEqual(resp.status_code, 200)
         data = json.loads(resp.get_data(as_text=True))
-        self.assertEqual(data, {"notifications": []})
+        self.assertEqual(data["status"], "OK")
+        self.assertEqual(data["data"], [])
 
     def test_get_notifications_valid_name(self):
         with hubs.tests.auth_set(app, self.user):
-            resp = self.app.get('/{}/notifications/'.format(
+            resp = self.app.get('/stream/saved/'.format(
                 self.user.username))
 
         self.assertEqual(resp.status_code, 200)
         data = json.loads(resp.get_data(as_text=True))
-        self.assertEqual(len(data["notifications"]), 1)
-
-        for saved in data["notifications"]:
-            self.assertEqual(saved['markup'], 'foo')
-            self.assertEqual(saved['link'], 'bar')
+        self.assertEqual(data["status"], "OK")
+        self.assertEqual(len(data["data"]), 1)
+        self.assertEqual(data["data"][0]['markup'], 'foo')
+        self.assertEqual(data["data"][0]['link'], 'bar')
 
 
 class TestPostNotifications(hubs.tests.APPTest):
@@ -48,18 +48,10 @@ class TestPostNotifications(hubs.tests.APPTest):
         'username': user.username,
     }
 
-    def test_post_notification_invalid_user(self):
-        with hubs.tests.auth_set(app, self.user):
-            resp = self.app.post(
-                '/{}/notifications/'.format('notarealfasuser'),
-                data=json.dumps(self.valid_payload),
-                content_type='application/json')
-        self.assertEqual(resp.status_code, 400)
-
     def test_post_notification_invalid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
-                '/{}/notifications/'.format(self.user.username),
+                '/stream/saved/',
                 data=json.dumps(self.invalid_payload),
                 content_type='application/json')
         self.assertEqual(resp.status_code, 400)
@@ -67,15 +59,16 @@ class TestPostNotifications(hubs.tests.APPTest):
     def test_post_notification_valid_payload(self):
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.post(
-                '/{}/notifications/'.format(self.user.username),
+                '/stream/saved/',
                 data=json.dumps(self.valid_payload),
                 content_type='application/json')
 
         self.assertEqual(resp.status_code, 200)
         data = json.loads(resp.get_data(as_text=True))
         self.assertTrue(isinstance(data, dict))
+        self.assertEqual(data["status"], "OK")
 
-        notification = data['notification']
+        notification = data['data']
         self.assertEqual(notification['markup'], 'foobar')
         self.assertEqual(notification['link'], 'baz')
 
@@ -107,7 +100,7 @@ class TestDeleteNotifications(hubs.tests.APPTest):
         self.assertIsNotNone(self.notification)
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.delete(
-                '/{}/notifications/{}/'.format(self.user.username, idx)
+                '/stream/saved/{}/'.format(idx)
             )
 
         self.assertEqual(resp.status_code, 200)
@@ -121,7 +114,7 @@ class TestDeleteNotifications(hubs.tests.APPTest):
 
         with hubs.tests.auth_set(app, self.user):
             resp = self.app.delete(
-                '/{}/notifications/{}/'.format(self.user.username, idx)
+                '/stream/saved/{}/'.format(self.user.username, idx)
             )
         self.assertEqual(resp.status_code, 404)
 
diff --git a/hubs/views/user.py b/hubs/views/user.py
index d40e393..64ebb81 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -11,12 +11,12 @@ from hubs.utils.views import (
     )
 
 
-@app.route('/<name>/stream')
-@app.route('/<name>/stream/')
+@app.route('/stream')
+@app.route('/stream/')
 @login_required
-@require_hub_access("view")
-def stream(name):
-    hub = get_hub(name)
+def stream():
+    username = flask.g.auth.user.username
+    hub = get_hub(username)
     widgets = get_visible_widgets(hub)
     return flask.render_template(
         'stream.html',
@@ -25,10 +25,10 @@ def stream(name):
     )
 
 
-@app.route('/<name>/stream/existing')
-@require_hub_access("view")
-def stream_existing(name):
-    hub = get_hub(name)
+@app.route('/stream/existing')
+@login_required
+def stream_existing():
+    username = flask.g.auth.user.username
     stream = hubs.stream.Stream()
     existing = json.loads(stream.get_json())
     # Right now, stream and actions are the same.
@@ -38,20 +38,18 @@ def stream_existing(name):
         ))
 
 
-@app.route('/<user>/notifications', methods=['GET', 'POST'])
-@app.route('/<user>/notifications/', methods=['GET', 'POST'])
+@app.route('/stream/saved', methods=['GET', 'POST'])
+@app.route('/stream/saved/', methods=['GET', 'POST'])
 @login_required
-def notifications(user):
+def saved_notifs():
+    user = flask.g.auth.user
     if flask.request.method == "GET":
-        saved = hubs.models.SavedNotification.by_username(user)
+        saved = hubs.models.SavedNotification.by_username(user.username)
         return flask.jsonify(dict(
             status="OK", data=[n.__json__() for n in saved],
             ))
     elif flask.request.method == "POST":
         data = flask.request.get_json()
-        user = hubs.models.User.by_username(user)
-        if not user:
-            return flask.abort(400)
         try:
             markup = data['markup']
             link = data['link']
@@ -73,10 +71,10 @@ def notifications(user):
             ))
 
 
-@app.route('/<user>/notifications/<int:idx>', methods=['DELETE'])
-@app.route('/<user>/notifications/<int:idx>/', methods=['DELETE'])
+@app.route('/stream/saved/<int:idx>', methods=['DELETE'])
+@app.route('/stream/saved/<int:idx>/', methods=['DELETE'])
 @login_required
-def delete_notifications(user, idx):
+def delete_notifs(idx):
     notification = flask.g.db.query(
         hubs.models.SavedNotification).filter_by(idx=idx).first()
     if not notification:

